-------------------------------------------------------------------------------
--|> KOS
--: Kill On Sight player tracking, notifications and visual indicators
-------------------------------------------------------------------------------
--|> INIT
-------------------------------------------------------------------------------
local weizPVP = weizPVP
weizPVP.KOS = {}
local KOS = weizPVP.KOS

--> KOS CORE FUNCTINONS
-------------------------------------------------------------------------------
function KOS.ClearStoredList()
    wipe(weizPVP.KosList)
end

--> KOS EVENTS
-------------------------------------------------------------------------------
KOS.Events = CreateFrame("Frame", "weizPVP.KOS.Frame", UIParent)
KOS.Events:SetPoint("CENTER")
KOS.Events:SetSize(32, 32)
KOS.Events:Hide()

--=> OnEvent
-------------------------------------------------------
KOS.Events:SetScript(
    "OnEvent",
    function(self, event, ...)
        return self[event] and self[event](self, ...)
    end
)

--=> Enable
-------------------------------------------------------
function weizPVP.KOS.Enable()
    KOS.Events:RegisterEvent("PLAYER_TARGET_CHANGED")
    KOS.Events:RegisterEvent("GLOBAL_MOUSE_UP")
end

--=> Disable
-------------------------------------------------------
function weizPVP.KOS.Disable()
    KOS.Events:UnregisterEvent("PLAYER_TARGET_CHANGED")
    KOS.Events:UnregisterEvent("GLOBAL_MOUSE_UP")
end

--> AddPlayer
-------------------------------------------------------
function KOS.AddPlayer(playerName)
    if not playerName then
        return
    end
    --> Add player to KOS list and refresh the core player list
    weizPVP.KosList[playerName] = true
    weizPVP.SortNearbyList()
    weizPVP.RefreshCurrentList()
    --> Refresh Crosshair is targeting the added player
    if (GetUnitName("target", true) == playerName) and weizPVP.Options.Crosshair.Enabled then
        weizPVP.Crosshair.Reset()
        weizPVP.Crosshair.NewTarget()
    end
end

--> RemovePlayer
-------------------------------------------------------
function KOS.RemovePlayer(playerName)
    --> Remove from KOS list and refresh list
    weizPVP.KosList[playerName] = nil
    weizPVP.SortNearbyList()
    weizPVP.RefreshCurrentList()
    --> Refresh Crosshair is targeting the added player
    if (GetUnitName("target", true) == playerName) and weizPVP.Options.Crosshair.Enabled then
        weizPVP.Crosshair.Reset()
        weizPVP.Crosshair.NewTarget()
    end
end
