-------------------------------------------------------------------------------
--|> UNIT MENU
--: Creates a new entry in the unit right click popup menu for adding/removing a player on the KOS list
-------------------------------------------------------------------------------
local weizPVP = weizPVP

--> INSERT BUTTON  ENTRY INTO THE"PLAYER" POPUP MENU
local info
local classColoredPlayerName
local playerName
local menuFrame
local unit
function weizPVP.KOS.Events.GLOBAL_MOUSE_UP(_, button)
    --> Confirm click was from the unit popup menu
    if button ~= "RightButton" then
        return
    elseif (not UnitPopup_HasVisibleMenu()) then
        return
    end
    menuFrame = UnitPopup_HasVisibleMenu() and UIDropDownMenu_GetCurrentDropDown() or nil
    unit = menuFrame.unit
    --> Verify enemy player
    if not UnitIsPlayer(unit) then
        return
    end
    if not (UnitIsEnemy("player", unit) or weizPVP.Options.DEBUG) then
        return
    end
    --> Get Popup menu frame
    if not (menuFrame) or (not unit) then
        return
    end
    --> Get player name and create class-colored name string
    playerName = GetUnitName(unit, true)
    classColoredPlayerName = WrapTextInColorCode(playerName, select(4, GetClassColor(weizPVP.PlayerDB[playerName].Class)))
    --> Build unit popup menu button
    info = {}
    info.text =
        weizPVP.KosList[playerName] and
        "|TInterface\\Addons\\weizPVP\\Addons\\KOS\\Media\\kos_icon_remove.tga:0|t |cff8fdaffRemove from|r |cffff0037KOS|r" or
        "|TInterface\\Addons\\weizPVP\\Addons\\KOS\\Media\\kos_icon_add.tga:0|t |cff8fdaffAdd to|r |cffff0037KOS|r"
    info.notCheckable = 1
    info.padding = 0
    info.leftPadding = 0
    info.func = function()
        weizPVP.KOS.ChangeKosStatus(classColoredPlayerName)
    end
    --> Add button to popup menu
    UIDropDownMenu_AddButton(info)
end
