-------------------------------------------------------------------------------
--|> LDB
-------------------------------------------------------------------------------
local weizPVP = weizPVP
local InterfaceOptionsFrame = InterfaceOptionsFrame
local addonName, _ = ...
local ldb = LibStub:GetLibrary("LibDataBroker-1.1", true)
if not ldb then
    return
end

local plugin =
    ldb:NewDataObject(
    addonName,
    {
        type = "data source",
        text = "0",
        icon = "Interface\\AddOns\\weizPVP\\Media\\Icons\\weizpvp_minimap.tga"
    }
)

function plugin.OnClick(_, button)
    if button == "RightButton" then
        --> RIGHT-CLICK = Toggle Interface Options
        if InterfaceOptionsFrame:IsShown() then
            InterfaceOptionsFrame:Hide()
        else
            InterfaceOptionsFrame_OpenToCategory("weizPVP")
            local _, Smax = InterfaceOptionsFrameAddOnsListScrollBar:GetMinMaxValues()
            InterfaceOptionsFrameAddOnsListScrollBar:SetValue(Smax)
            --> Run twice (blizz bug work around)
            InterfaceOptionsFrame_OpenToCategory("weizPVP")
        end
    elseif button == "LeftButton" then
        --> LEFT-CLICK = Toggle window
        weizPVP.Options.Window.Visible = not weizPVP.Options.Window.Visible
        weizPVP.SetWindowSettings()
    end
end

hooksecurefunc(
    weizPVP,
    "UpdateNearbyCount",
    function()
        plugin.text = weizPVP.HeaderFrame.TitleVar:GetText()
        plugin.icon = "Interface\\AddOns\\weizPVP\\Media\\Icons\\weizpvp_minimap.tga"
    end
)

function plugin.OnTooltipShow(tip)
    tip:AddDoubleLine(
        "|cffffffffweiz|r|cffffa012PVP|r",
        weizPVP.HeaderFrame.TitleVar:GetText(),
        nil,
        nil,
        nil,
        0.2,
        1,
        0.2
    )
    tip:AddLine(" ")
    tip:AddDoubleLine("Right-Click", "|cff00ff05Toggle Options|r", nil, nil, nil, 0.2, 1, 0.2)
    tip:AddDoubleLine("Left-Click", "|cff00ff05Toggle weizPVP window visibility|r", nil, nil, nil, 0.2, 1, 0.2)
end

local f = CreateFrame("Frame")
f:SetScript(
    "OnEvent",
    function()
        local icon = LibStub("LibDBIcon-1.0", true)
        if not icon then
            return
        end
        icon:Register(addonName, plugin, weizPVP.Options.LDB)

        if weizPVP.Options.LDB.minimap == true then
            LibStub("LibDBIcon-1.0"):Show("weizPVP")
        else
            LibStub("LibDBIcon-1.0"):Hide("weizPVP")
        end
    end
)
f:RegisterEvent("PLAYER_LOGIN")
